require "import"
import "android.speech.RecognizerIntent"
import "android.speech.SpeechRecognizer"
import "android.speech.RecognitionListener"
import "com.androlua.*"
import "android.net.Uri"
import "android.content.Intent"

local spokenWords = ""  -- Variable to store the recognized text

-- Function to handle errors
function onError(errorMessage)
    local editText = service.getEditText()
    if editText == nil then
        print("No text box exists")
    else
        print("Error:", errorMessage)
    end
    return false
end

-- Function to start Hindi voice recognition
function startHindiVoiceTyping()
    local verbalizationDetected = false

    local recognizerIntent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "hi-IN")  -- Set language to Hindi
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE, this.getPackageName())

    local speechRecognizer = SpeechRecognizer.createSpeechRecognizer(this)

    local speechListener = RecognitionListener{
        onResults = function(results)
            local data = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
            if data ~= nil and data.size() > 0 then
                verbalizationDetected = true
                spokenWords = data.get(0)  -- Store the recognized text

                -- Insert the recognized text into the text box
                local editText = service.getEditText()
                service.insertText(editText, spokenWords .. " ")

                -- Speak out the recognized text (optional)
                -- this.speak(spokenWords)
            end

            if not verbalizationDetected then
                onError("No speech detected")  -- Provide a specific error message
            end
        end,
        onError = onError
    }

    speechRecognizer.setRecognitionListener(speechListener)
    speechRecognizer.startListening(recognizerIntent)
end

-- Example usage:
startHindiVoiceTyping()